import {visit} from "unist-util-visit";
import {h} from "hastscript";
import {getHighlighter} from "shiki";
function parseMeta(value) {
  return value ? {highlightedLines: JSON.parse(value)} : {highlightedLines: []};
}
function parseLanguage(className) {
  if (!className || className === "")
    return null;
  const languageClasses = className.split(" ").filter((c) => c.startsWith("language-")).map((c) => c.substring(c.indexOf("-") + 1));
  return languageClasses.length > 0 ? languageClasses[0] : null;
}
const advancedCodeBlock = function advancedCodeBlock2() {
  const transformCode = (highlighter) => (node) => {
    var _a, _b;
    const lang = parseLanguage(String((_a = node.properties) == null ? void 0 : _a.className));
    if (lang === null || node.children.length !== 1 || node.children[0].type !== "text") {
      return;
    }
    const meta = parseMeta((_b = node.data) == null ? void 0 : _b.meta);
    const tokens = highlighter.codeToThemedTokens(node.children[0].value, lang);
    node.children = tokens.map((line, zeroIndexedLineNumber) => h(".codeblock-line", meta.highlightedLines.includes(zeroIndexedLineNumber + 1) ? {dataHighlight: true} : {}, line.length === 0 ? " " : line.map((token) => h("span", {style: `color: ${token.color || "inherit"}`}, token.content))));
    if (!node.properties) {
      node.properties = {style: ""};
    }
    node.properties.style = `color: ${highlighter.getForegroundColor()}; background-color: ${highlighter.getBackgroundColor()};` + node.properties.style;
  };
  return async function codeBlockProcessor(tree) {
    const highlighter = await getHighlighter({theme: "monokai"});
    visit(tree, {type: "element", tagName: "code"}, transformCode(highlighter));
  };
};
var src_default = advancedCodeBlock;
export {
  src_default as default
};
